using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using System.Threading;

namespace Benday.SequenceGenerator.Business
{
    public class SequenceFactory
    {
        private static SequenceFactory m_instance;

        private IDictionary<string, Sequence> m_sequences;

        private SequenceFactory()
        {
            m_sequences = new Dictionary<string, Sequence>();
        }

        public static SequenceFactory Instance
        {
            get
            {
                if (m_instance == null)
                {
                    m_instance = new SequenceFactory();
                }

                return m_instance;
            }
        }

        public Sequence GetSequence(string name)
        {
            if (m_sequences.ContainsKey(name) == true)
            {
                return m_sequences[name];
            }
            else
            {
                Sequence returnValue = new Sequence(name);

                m_sequences.Add(name, returnValue);

                return returnValue;
            }
        }
    }
}
