﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Benday.SequenceGenerator.Business;

namespace Benday.SequenceGenerator.WebUi
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.IsPostBack == false)
            {
                LoadAllSequences();
            }
        }

        protected void m_btnNextSequenceValue_Click(object sender, EventArgs e)
        {
            if (m_listSequences.SelectedItem != null)
            {
                m_labelTime.Text = DateTime.Now.ToString();

                var seq = SequenceFactory.Instance.GetSequence(m_listSequences.SelectedValue);

                m_labelNextSequenceValue.Text = seq.NextValue().ToString();    
            }            
        }

        protected void m_btnCreateNewSequence_Click(object sender, EventArgs e)
        {
            m_labelTime.Text = DateTime.Now.ToString();

            var seq = SequenceFactory.Instance.GetSequence(m_textSequenceName.Text);

            m_labelNextSequenceValue.Text = seq.NextValue().ToString();

            LoadAllSequences();
        }

        private void LoadAllSequences()
        {
            m_listSequences.Items.Clear();

            SequenceInformationService service = new SequenceInformationService();

            var existingSequences = service.GetList();

            if (existingSequences == null)
            {
                // do nothing
            }
            else
            {
                foreach (var seq in existingSequences)
                {
                    m_listSequences.Items.Add(new ListItem(seq.Name));
                }
            }

        }
    }
}